import os
from turtle import pd
import numpy as np
import imageio

import torch
import pytorch3d

from starter.utils import get_device, get_mesh_renderer, load_cow_mesh

from utils_yc import init_mesh, render_360

if __name__ == '__main__':

    out_d = 'output'
    if not os.path.exists(out_d): os.makedirs(out_d)

    device = get_device()

    # renderer
    image_size = 256
    renderer = get_mesh_renderer(image_size=image_size)

    v1 = torch.tensor([1, 0, 0])
    v2 = torch.tensor([-1, 0, 0])
    v3 = torch.tensor([0, 0, np.sqrt(3)])
    v4 = torch.tensor([0, np.sqrt(8/3), 1/np.sqrt(3)])

    verts = torch.stack([v1, v2, v3, v4]).float()

    verts = verts - verts.mean(0)

    faces = torch.tensor([
                [0, 1, 2],
                [0, 1, 3],
                [0, 2, 3],
                [1, 2, 3],
                ]).long()

    mesh = init_mesh(verts, faces, device=device)

    imgs = render_360(mesh, renderer)

    imageio.mimsave(f'{out_d}/q2.1_tetrahedron.gif', imgs, fps=15)