import os
from turtle import pd
import numpy as np
import imageio

import torch
import pytorch3d

from starter.utils import get_device, get_mesh_renderer, load_cow_mesh

from utils_yc import init_mesh, render_360

if __name__ == '__main__':

    out_d = 'output'
    if not os.path.exists(out_d): os.makedirs(out_d)

    device = get_device()

    # renderer
    image_size = 256
    renderer = get_mesh_renderer(image_size=image_size)

    v1 = torch.tensor([1, 0, 0])
    v2 = torch.tensor([0, 0, 0])
    v3 = torch.tensor([0, 0, 1])
    v4 = torch.tensor([1, 0, 1])
    v5 = torch.tensor([1, 1, 0])
    v6 = torch.tensor([0, 1, 0])
    v7 = torch.tensor([0, 1, 1])
    v8 = torch.tensor([1, 1, 1])

    verts = torch.stack([v1, v2, v3, v4, v5, v6, v7, v8]).float()

    verts = verts - verts.mean(0)

    faces = torch.tensor([
                [0, 1, 2],
                [0, 2, 3],
                [0, 1, 5],
                [0, 4, 5],
                [1, 2, 6],
                [1, 5, 6],
                [2, 3, 7],
                [2, 6, 7],
                [0, 3, 7],
                [0, 4, 7],
                [4, 5, 6],
                [4, 6, 7],
                ]).long()

    mesh = init_mesh(verts, faces, device=device)

    imgs = render_360(mesh, renderer, elev=20)

    imageio.mimsave(f'{out_d}/q2.2_cube.gif', imgs, fps=15)